#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

#define N_THREADS 5

pthread_mutex_t lock_print;

void print_no_lock(int n_times, int thread_id)
{
  for (int i = 0; i < n_times; i++) {
    printf("Thread %d\n", thread_id);
    usleep(100);
  }
}

void print_lock(int n_times, int thread_id)
{
  // In questa funzione facciamo in modo che un solo thread
  // alla volta possa chiamare la funzione di stampa dato che
  // è protetta da un lock
  pthread_mutex_lock(&lock_print);
  print_no_lock(n_times, thread_id);
  pthread_mutex_unlock(&lock_print);
}

void * run_thread(void * arg)
{
  int * message = (int *) arg;
  print_no_lock(10, *message);
  return NULL;
}

int main(int argc, char * argv[])
{
  pthread_mutex_init(&lock_print, NULL);
  int ids[N_THREADS];
  pthread_t threads[N_THREADS];
  for (int i = 0; i < N_THREADS; i++)
  {
    ids[i] = i;
    pthread_create(&threads[i], NULL, run_thread, &ids[i]);
  }
  for (int i = 0; i < N_THREADS; i++)
  {
    pthread_join(threads[i], NULL);
  }
  return 0;
}
